"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = generate;
exports.schemaToInputs = schemaToInputs;
exports.schemaItemToIonInput = schemaItemToIonInput;
const fs_1 = __importDefault(require("fs"));
const logger_1 = __importDefault(require("../utils/logger"));
const ionForm = __importStar(require("../templates/ionicFormInput.template"));
function generate(jsonSchema, outFile) {
    var _a;
    logger_1.default.process("vuelidate", (_a = jsonSchema === null || jsonSchema === void 0 ? void 0 : jsonSchema["x-documentConfig"]) === null || _a === void 0 ? void 0 : _a.documentName);
    const content = ionForm.makeComponent(jsonSchema, schemaToInputs(jsonSchema));
    logger_1.default.writing("Ionic Form", outFile);
    return fs_1.default.writeFileSync(outFile, content);
}
function schemaToInputs(schema) {
    const props = schema.properties;
    let form = "";
    Object.keys(props).forEach((key) => {
        const item = props[key];
        form += schemaItemToIonInput(key, item);
    });
    return form;
}
function schemaItemToIonInput(key, value) {
    let result = "";
    const xInputType = value["x-inputType"] ? value["x-inputType"] : "";
    const xFormat = value["x-format"] ? value["x-format"] : "";
    const xForeignKey = value["x-foreignKey"] ? value["x-foreignKey"] : "";
    const valType = value.type;
    const TypeString = valType == "string";
    const TypeNumber = valType == "number";
    const TypeBoolean = valType == "boolean";
    const FormatInt = xFormat == "integer";
    const FormatFloat = xFormat == "float";
    const FormatUnixTime = xFormat == "unixTimestamp";
    if (TypeString) {
        switch (xInputType) {
            case "textArea":
                result = ionForm.textAreaTemplate(key, value);
                break;
            case "plainText":
            default:
                result = ionForm.plainTextTemplate(key, value);
                break;
        }
    }
    else if (TypeNumber) {
        switch (xInputType) {
            case "datetime":
                if (FormatUnixTime) {
                    result = ionForm.dateTimeTemplate(key, value);
                }
                ;
                break;
            case "date":
                if (FormatUnixTime) {
                    result = ionForm.dateTemplate(key, value);
                }
                ;
                break;
            case "time":
                if (FormatUnixTime) {
                    result = ionForm.timeTemplate(key, value);
                }
                ;
                break;
            case "integer":
                result = ionForm.integerTemplate(key, value);
                break;
            case "float":
            default:
                result = ionForm.floatTemplate(key, value);
                break;
        }
    }
    else if (TypeBoolean) {
        switch (xInputType) {
            case "checkbox":
                result = ionForm.checkboxTemplate(key, value);
                break;
            case "switch":
            default:
                result = ionForm.switchTemplate(key, value);
                break;
        }
    }
    ;
    const inpSelect = Array.isArray(value.enum);
    if (xForeignKey || inpSelect) {
        result = ionForm.selectOptionTemplate(key, value);
    }
    return result;
}
;
exports.default = {
    generate,
    schemaItemToIonInput
};
